#include <core> 
#include <console> 
#include <string> 
#include <admin> 
#include <adminlib> 

#define ACCESS_CONSOLE 131072

new STRING_VERSION[MAX_DATA_LENGTH] = "26.07.03";

new Key[]="am_sound";

/*PLUGIN SETTINGS*/
new g_FileName[MAX_TEXT_LENGTH];
new g_SoundConnect[MAX_TEXT_LENGTH];
new g_SoundDisconnect[MAX_TEXT_LENGTH];
new g_Announce_Delay;
new g_iRed;
new g_iGreen;
new g_iBlue;

/*PLAYER DATABASE*/
#define MAX_ENTRIES	31
new g_WONID[MAX_ENTRIES][MAX_NUMBER_LENGTH];
new g_SOUND[MAX_ENTRIES][MAX_TEXT_LENGTH];
new g_real_entries;

public plugin_init() {
	check_values();
	return PLUGIN_CONTINUE; 
}

check_values(){
	new Text[MAX_TEXT_LENGTH];
	new Vault[MAX_TEXT_LENGTH];
	new error;
	new fileaccess;
	new clientexec;
		
	fileaccess=getvar("file_access_read");
	clientexec=getvar("allow_client_exec");
	getstrvar("admin_vault_file",Vault,MAX_TEXT_LENGTH);
	snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] -------- CHECKING VALUES --------");
	log(Text);
	if(!fileexists(Vault)){
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] vault.ini not defined in adminmod.cfg!!");
		error++;
		log(Text);
	}
	if(!fileaccess){
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] file_access_read must set to 1 in adminmod.cfg!!");
		error++;
		log(Text);
	}
	if(!clientexec){
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] allow_client_exec must set to 1 in adminmod.cfg!!");
		error++;
		log(Text);
	}
	if(error==0){
		get_vaultdata( "CONNECT_FILE", g_FileName, MAX_TEXT_LENGTH);
		if(fileexists(g_FileName)){
			snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] connectsound.cfg: '%s'",g_FileName);
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] connectsound.cfg could not be found!!");
			error++;
		}
		log(Text);
		
		if(error!=0){
			plugin_registerinfo("Client Connect Greeting!","TOO MANY ERRORS! PLUGIN DISABLED!",STRING_VERSION);
			snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] FATAL ERROR! Please check your file destination entrie in vault.ini!!");
			log(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] ------------------------------------------");
			log(Text);
		}else{	
			get_vaultdata( "CONNECT_SNDCON", g_SoundConnect, MAX_TEXT_LENGTH);
			get_vaultdata( "CONNECT_SNDDISC", g_SoundDisconnect, MAX_TEXT_LENGTH);
			if(fileexists(g_SoundConnect)){
				snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] default connect sound: '%s'",g_SoundConnect);			
			}else{
				snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] default connect sound could not be found!!");
				error++;
			}
			log(Text);
			if(fileexists(g_SoundDisconnect)){
				snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] default disconnect sound: '%s'",g_SoundDisconnect);
			}else{
				snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] default disconnect sound could not be found!!");
				error++;
			}
			log(Text);
			if(error!=0){
				snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] WARNING: %i default sound(s) is/are not set in vault.ini!!",error);
				log(Text);
			}
			get_vaultnumdata("CONNECT_DELAY",g_Announce_Delay);
			if(g_Announce_Delay==0){
				g_Announce_Delay=4;
				set_vaultnumdata( "CONNECT_DELAY", g_Announce_Delay );
			}
			get_vaultnumdata("CONNECT_COLOR_RED",g_iRed);
			if(g_iRed==0){
				g_iRed=255;
				set_vaultnumdata( "CONNECT_COLOR_RED", g_iRed );
			}
			get_vaultnumdata("CONNECT_COLOR_GREEN",g_iGreen);
			if(g_iGreen==0){
				g_iGreen=255;
				set_vaultnumdata( "CONNECT_COLOR_GREEN", g_iGreen );
			}
			get_vaultnumdata("CONNECT_COLOR_BLUE",g_iBlue);
			if(g_iBlue==0){
				g_iBlue=255;
				set_vaultnumdata( "CONNECT_COLOR_BLUE", g_iBlue );
			}
			snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] delay connect: '%i'",g_Announce_Delay);
			log(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] RGB-Color-RED: '%i'",g_iRed);
			log(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] RGB-Color-GREEN: '%i'",g_iGreen);
			log(Text);
			snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] RGB-Color-BLUE: '%i'",g_iBlue);
			log(Text);
			plugin_registerinfo("Client Connect Greeting!","Announces and Greets Every Player That Connects!",STRING_VERSION);
			plugin_registercmd("sdal_connect", "sdal_connect", ACCESS_CONSOLE);
			exec( "logd_reg 51 admin_command sdal_connect" );		/*ENTER-EVENT*/
			read_file();
		}			
	}else{
		plugin_registerinfo("Client Connect Greeting!","TOO MANY ERRORS! PLUGIN DISABLED!",STRING_VERSION);
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] FATAL ERROR! Please check your entries in adminmod.cfg");
		log(Text);
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] ------------------------------------------");
		log(Text);
	}
}

read_file(){
	new Data[MAX_TEXT_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new i;
	new j;
	
	g_real_entries=0;
	snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] ------------- READING ---------------");
	log(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] * Reading '%s'",g_FileName);
	log(Text);
	j=filesize(g_FileName);
	if(j>=MAX_ENTRIES){
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] To many entries in %s! Max: %i  ",g_FileName,MAX_ENTRIES-1);
		log(Text);
		j=MAX_ENTRIES-1;
	}
	for(i=1;i<=j;i++){
		readfile(g_FileName,Data,i,MAX_TEXT_LENGTH);
		strsep(Data," ",g_WONID[g_real_entries],MAX_NUMBER_LENGTH,g_SOUND[g_real_entries],MAX_NAME_LENGTH);
		if(!fileexists(g_SOUND[g_real_entries])){
			snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] Sound-File: '%s' not found. Registration invalid! ",g_SOUND[g_real_entries]);
			log(Text);
		}else{
			g_real_entries++;
		}
	}
	g_real_entries--;
	snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] %i WONIDS and Sounds loaded!",g_real_entries+1);
	log(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"[SDAL_CONNECT] ------------------------------------------");
	log(Text);
	return PLUGIN_CONTINUE;
}

/*CLIENT SET-INFO FOR ENABLING SOUNDS */
allowsound(User[]){
	new Info[MAX_NUMBER_LENGTH];
	new iInfo;
	new Authid[MAX_AUTHID_LENGTH];
	get_userAuthID(User,Authid,MAX_AUTHID_LENGTH);
	if(strcmp(Authid,"BOT")!=0){
		get_userinfo(User,Key,Info,MAX_NUMBER_LENGTH);
		iInfo=strtonum(Info);
		if(strlen(Info)==0){/*if no setinfo exists, set it to 1*/
			snprintf(Info,MAX_TEXT_LENGTH,"setinfo ^"%s^" ^"1^"",Key);
			execclient(User,Info);
			return 1;
		}
		if(iInfo>=1){
			return 1;
		}else{
			return 0;
		}
		return 0;
	}
	return 0;
}

playFile(sFileName[]){
	new Name[MAX_NAME_LENGTH];
	new iPlayerCount = maxplayercount( );
	new i;
	new idummy;
	new Authid[MAX_AUTHID_LENGTH];

	for( i=1; i <= iPlayerCount; i++ ){
		if( playerinfo( i, Name, MAX_NAME_LENGTH,idummy,idummy,idummy,idummy,Authid ) ){
			if(allowsound(Name)){
				playsound(Name,sFileName);
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public sdal_connect(HLCommand,HLUserIndex){
	new strUserIndex[MAX_NUMBER_LENGTH];
	convert_string(HLUserIndex, strUserIndex, MAX_NUMBER_LENGTH);
	set_timer("ann_timer",g_Announce_Delay, 0, strUserIndex);
	return PLUGIN_CONTINUE; 
}

public ann_timer(Timer,Repeat,HLName,HLParam) {
	new strUserIndex[MAX_NUMBER_LENGTH]; 
	convert_string(HLParam,strUserIndex,MAX_NUMBER_LENGTH);
	plr_announce(strUserIndex, 1);
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName, UserIndex) {
	new strUserIndex[MAX_NUMBER_LENGTH];
	numtostr(UserIndex,strUserIndex);
	plr_announce(strUserIndex, 0);
	return PLUGIN_CONTINUE; 
} 

plr_announce(UserIndex[], lConnect) { 
	new Text[MAX_TEXT_LENGTH];
	new strName[MAX_NAME_LENGTH];
	new strWONID[MAX_NUMBER_LENGTH];
	new uindex;
	new iWONID;
	new i;
	new x;
	
	uindex=strtonum(UserIndex);
	
	if(playerinfo(uindex,strName,MAX_NAME_LENGTH,_,iWONID)){
		numtostr(iWONID,strWONID);
		for(i=0;i<=g_real_entries;i++){
			if(strcmp(g_WONID[i],strWONID)==0){
				x=1;
				break;
			}
		}
		
		if (lConnect == 1) {
			snprintf(Text,MAX_TEXT_LENGTH,"Welcome^n%s^nEnjoy playing here!!",strName);
			if(x==0){
				playFile(g_SoundConnect);
			}else{
				playFile(g_SOUND[i]);
			}
		} else {
			snprintf(Text,MAX_TEXT_LENGTH,"%s^nhas left but will return again!",strName);
			if(x==0){
				playFile(g_SoundDisconnect);
			}else{
				playFile(g_SOUND[i]);
			}
		}
		typesay(Text,12,g_iRed,g_iGreen,g_iBlue);
	}
	return PLUGIN_CONTINUE; 
}